package ejb31.war.servlet;

import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptors;
import javax.interceptor.InvocationContext;
import javax.ejb.Stateless;
import javax.annotation.Resource;

@Stateless
@Interceptors(ProfilingInterceptor.class)
// identify external interceptors
public class HelloBean implements HelloLocal {

@Resource
private javax.ejb.SessionContext ctx;

    public void sayHello() {
        System.out.println("Hello from your first interceptor-enabled bean!");
    }

    @AroundInvoke
    // mark this method as a bean interceptor
    public Object checkPermission(InvocationContext ic) throws Exception {
        System.out.println("*** checkPermission interceptor invoked");
 
        // you can implement your own security framework using interceptors
        if (!ctx.getCallerPrincipal().getName().equals("oc4jadmin")) {
            throw new SecurityException("Caller: '"
                    + ctx.getCallerPrincipal().getName()
                    + "' does not have permissions for method "
                    + ic.getMethod());
        }
        return ic.proceed();
    }

}
